/////////////////////////////////////
//Fonctions de cration de niveau
/////////////////////////////////////

function GetLevelData(Numero:int,Not_Mute:Boolean=true):Niveau
{
	const NIVEAUX_JETONS:Array=new Array(3,4,5,4,5,5,3,5,6,7,5,7);
	var Hook:Array=new Array(); //Vide la liste des Hook.
	var Non_Extinctible:Array=new Array(); //Vide la liste des Non_Extinctible.
	var Niveau_datas:Array; //Contient l'arborescence sous forme numrique
	var Inutile:Array=null;//Evite de recrire compltement un niveau lors de sa modification
	var Message:String="";

	function T(...Liste):Array
	{//T comme Tableau
	//Plus court  crire que new Array()  chaque fois
		return Liste;
	}
	if(Numero==0)
	{
		Niveau_datas=new Array(null,null,T(0,1));
		Message ="<u>Rgles d'A-graphe : <font size=\"-2\"><i>(partie 1/3)</i></font></u><br><li><b>Rgle n1 : </b> Pour allumer un noeud (represent par un cercle), cliquer dessus.</li><li><b>Rgle n2 : </b> Pour terminer un niveau, allumer le noeud principal, centr en haut.</li><li><b>Rgle n3 : </b> Un noeud est allumable si et seulement si tous ses enfants (les noeuds qui descendent de lui) sont allums.</li>";
	}

	else if(Numero==1)
	{
		Niveau_datas=new Array(null,null,null,T(0,1,2),null,null,T(4,5),T(3,6));
		Message = "<u>Rgles d'A-graphe : <font size=\"-2\"><i>(partie 2/3)</i></font></u><br><li><b>Rgle n4 : </b> Il est interdit d'allumer simultanment plus de noeuds que le nombre imparti pour chaque niveau (ce nombre est affich en haut,  droite).</li><li><b>Rgle n5 : </b> Une fois un noeud allum, on peut teindre ses enfants sans que cela teigne le parent.</li>";
	}
	else if(Numero==2)
	{
		Niveau_datas=new Array(null,null,T(0,1),null,null,T(1,3,4),null,T(4,6),null,T(8),T(9),T(2,5,7,10));
		Message = "<u>Rgles d'A-graphe : <font size=\"-2\"><i>(partie 3/3)</i></font></u><br><li><b>Rgle n6 : </b> Un noeud allum puis teint ne peut pas tre rallum.</li><li><b>Rgle n7 : </b> Les noeuds marqus d'une croix ne peuvent pas tre teints.</li><br>Voil, c'est tout pour les rgles. Bonne chance !";
	}
	else if(Numero==3)
		Niveau_datas=new Array(null,null,null,T(0),T(3,2),T(1,0),T(5,0,4));
 	else if(Numero==4)
 	{
		Niveau_datas=new Array( null,null,null,T(0,1,2),null,null,T(4,5),T(3,6),null,null,T(8,9),null,null,T(11,12),null,null,T(14,15),T(10,13,16),null,T(17,18),T(7,19));
	}
	else if(Numero==5)
	{
		Niveau_datas=new Array(null,null,null,T(0),T(0,2),T(2),T(3,4,5),T(1),T(3,4,5),T(6,7,8));
		Hook[1]=1;
		Message = "<li><b>Dernier niveau du tutorial.</b> Les choses vont rapidement se gter ! Bonne chance pour la suite...</li><li>Un conseil avant de nous quitter : pensez  bien vrifier l'agencement des noeuds avant de commencer : certains sont un peu tratres...</li>";
	}
	else if(Numero==6)
	{
		Niveau_datas=new Array(null,T(0),null,null,T(3),T(2,3),T(4),T(5,6),T(1,7));
		Hook[3]=-1;
	}
	else if(Numero==7)
	{
		Niveau_datas=new Array(null,T(0),T(0),T(0),T(1),T(1,2),T(2,3),T(3),T(4,5),T(5,6,7),T(8),null,T(9,11),T(10),T(12),T(13,14),T(13,15),T(14,11,7),T(16,15,17));
		//Hook[15]=-1;
 		Non_Extinctible[7]=true;
	}
	else if(Numero==8)
	{
		Niveau_datas=new Array(null,T(0),null,T(0,2),T(1),T(4),T(1,0),T(3,2),T(5,4),null,null,null,T(9,10),T(10,11),T(12),T(13),T(14),T(15),T(12),T(13),T(10),T(16,18,20,19,17),T(6,7,8),T(21,22));
	}
	else if(Numero==9)
		Niveau_datas=new Array(null,T(0),T(0),T(1),T(1,0),T(2,0),T(2),T(3),T(3,1,4),T(5,6),T(6),T(7,3,8),T(9,10),T(11,8,4,5,9,12));
	else if(Numero==10)
		Niveau_datas=new Array(null,null,null,null,T(0,1),T(2,3),T(4),T(4),T(5),T(5),T(6),T(6,7),T(7),T(8),T(9),T(10,11,12),T(13,14),T(15),T(15,16),T(16),null,null,null,null,null,T(22,20,23),T(23,21,24),T(25,26),T(17,18),T(18,19),T(28,29),T(30,27));
	else if(Numero==11)
		Niveau_datas=new Array(null,T(0),T(0),T(0),T(1,0),T(1,0,2),T(1,2,3),T(4,5,6),T(5,0,6),T(0,6),T(7,8,9));

	if(Message!="" && Not_Mute && !Mode2Joueurs)
		ShowMessage(Message);
	if(Mode2Joueurs)
		ShowMessage("<u>Niveau en mode 2 Joueurs</u><li>Les informations du niveau sont affiches en haut,  droite.</li><li>N'oubliez pas que vous pouvez teindre des noeuds ! Votre tour ne se finit que quand vous en allumez un.</li>");

	return LoadNiveau(Niveau_datas,Numero.toString(),NIVEAUX_JETONS[Numero],Hook,Non_Extinctible);
}

function String2Level(Niv_String:String,Titre:String="Mon niveau perso",NbJetons:int=5):Niveau
{//Cre un niveau  partir d'un string.
//Utilis en mode 2 joueurs, mais aussi lors de la rsolution automatique d'un niveau.
	var Hook:Array=new Array(); //Vide la liste des Hook.
	var Non_Extinctible:Array=new Array(); //Vide la liste des Non_Extinctible.
	var Allumes:Array=new Array();
	var DejaAllumes:Array=new Array();
	var i:int=0;
	var Niv_Array:Array=Niv_String.split(",");
	function ReplaceNullItem(T:Array):void
	{

		if(T.length>1)
		{
			for(var j:int=0;j<T.length;j++)
			{//On ne peut pas utiliser for each, car String est un type primitif : on agirait sur une copie de l'objet.
				if(T[j]=="null")
					T[j]=null;
			}
		}
	}


	for(i=0;i<Niv_Array.length;i++)
	{//Trouver les Hook, les allums et les non exctinctibles.
		if(Niv_Array[i]!=Niv_Array[i].replace("X",""))
		{//ajouter NonExtinctible
			Niv_Array[i]=Niv_Array[i].replace("X","");
			Non_Extinctible[i]=true;
		}
		if(Niv_Array[i]!=Niv_Array[i].replace("@",""))
		{//ajouter NonExtinctible
			Niv_Array[i]=Niv_Array[i].replace("@","");
			Allumes[i]=true;
		}
		if(Niv_Array[i]!=Niv_Array[i].replace("-",""))
		{//ajouter un Hook
			Niv_Array[i]=Niv_Array[i].replace("-","");
			Hook[i]=-1;
		}
		if(Niv_Array[i]!=Niv_Array[i].replace("+",""))
		{//ajouter un Hook
			Niv_Array[i]=Niv_Array[i].replace("+","");
			Hook[i]=1;
		}
		if(Niv_Array[i]!=Niv_Array[i].replace("!",""))
		{//ajouter un Hook
			Niv_Array[i]=Niv_Array[i].replace("!","");
			DejaAllumes[i]=true;
		}
	}
	//Remplacer "null" par...le vrai null
	ReplaceNullItem(Niv_Array);

	for(i=0;i<Niv_Array.length;i++)
	{//On ne peut pas utiliser for each, car String est un type primitif
		if(Niv_Array[i]!=null && Niv_Array[i].indexOf("/")!=-1)
		{
			Niv_Array[i]=Niv_Array[i].split("/");
			Niv_Array[i].pop();//Supprimer le dernier item, qui est null
			ReplaceNullItem(Niv_Array[i]);
		}
	}
	return LoadNiveau(Niv_Array,Titre,NbJetons,Hook,Non_Extinctible,Allumes,DejaAllumes);
}

function ChargementNiveauDirect(e:Event):void
{//Trigger quand clic sur une des miniatures dans Boite.
	while(Boite.numChildren > 0)
		Boite.removeChildAt(0);

	Boite.addChild(ChangeLevelInfo);

	ChangeLevelInfo.htmlText="<u>Chargement en cours</u> (niv. <b>"+e.currentTarget.NumeroNiveau+"</b>)";
	if(e.currentTarget.Officiel)
	{
		NumeroNiveauActuel=e.currentTarget.NumeroNiveau;
		LancerNouveauNiveau(e.currentTarget.NumeroNiveau);
	}
	else
		LancerChargement();
}


function LoadNiveau( Level:Array,NumNiveau:String,NBJetons:int,Hook:Array,Non_Extinctible:Array,Allumes:Array=null,DejaAllumes:Array=null):Niveau
{//La fonction principale, qui charge le niveau dans un sprite
	var Layer:Niveau; //Layer est le Sprite qui doit contenir le niveau
	if(Allumes==null)
		Allumes=new Array();
	if(DejaAllumes==null)
		DejaAllumes=new Array();
	Layer=new Niveau(NumNiveau,Level,Hook,Non_Extinctible,Allumes,DejaAllumes,NBJetons,FlashHeight,FlashWidth,Mode2Joueurs);
	GrandPere=Layer.All_Noeuds[Level.length-1];
	//Puis rgler les positions Y.
	//Pour cela, il faut d'abord trouver le nombre d'imbrications.
	//Facile ! Il suffit d'appeler GrandPere.Profondeur(), qui est rcursive.
	GrandPere.GererXY(1,GrandPere.Profondeur(),FlashWidth-20,FlashWidth/2 -10);
	GrandPere.RecreerArbreLien();
	Layer.CreerArbreParents(GrandPere);
	return Layer;
}